# Schema repo

the schema repo stores JSON Schema's for use in auto-view generation.

it allows registering schemas, retrieving them.
registering named custom views (components) and retriving them
it can be used to create your own auto-view generators.


## API

* constructor:
```ts
SchemaRepo(parentRepo?:SchemaRepo);
```
params:
* parentRepo: schemaRepo to inherit definitions from

* addSchema:

adds a schema definition to repo
```ts
myRepo.addSchema(def:JSONSchema)
```

* addSchemas:

adds a schema definition to repo
```ts
myRepo.addSchemas(defs:JSONSchema[])
```

* getSchema:

returns a JSON schema if exists

```ts
myRepo.getSchema(id:string):JSONSchema | null
```

* getView:

returns a view from a JSON schema if both exists

```ts
myRepo.getView(schemaId:string,viewName:string):AutoViewsViewSchema | null
```

* registerController:

registers a component to a unique name

```ts
myRepo.registerController<D>(controllerId:string,controller:React.ComponentClass,valueProp:string = "value", onChangeProp:string = "onChange"):void
```

* getController:

gets a component according to a unique name, returns null if not found

```ts
myRepo.getController<D>(controllerId:string):React.ComponentClass | null
```

* registerIcon:

registers an icon to a unique icon name

```ts
myRepo.registerIcon<D>(iconId:string,icon:string):void
```
