/// <reference types="react" />
import * as React from 'react';
import { SchemaRepository } from "./schema-repo";
import { AutoFormEvent, DisplayMode } from "./form-entry";
import { SchemaProperty } from "./schema-property";
export declare type AutoFormOnChangeType = (e: AutoFormEvent) => void;
export interface AutoFormProps extends React.HTMLAttributes<HTMLFormElement> {
    repo: SchemaRepository;
    schemaId: string;
    displayMode: DisplayMode;
    formData: any;
    onAutoViewChange?: AutoFormOnChangeType;
    entryKey?: string;
}
export declare function newSchemaRepository(): SchemaRepository;
export declare function fieldValueSelector(key: string): string;
export declare function fieldLabelSelector(key: string): string;
export declare function autoFormSelector(key: string): string;
export interface AutoFormContext {
    isInternal: boolean;
}
export declare class AutoForm extends React.Component<AutoFormProps, {}> {
    static defaultProps: {
        entryKey: string;
    };
    context: AutoFormContext;
    static contextTypes: {
        isInternal: () => null;
    };
    static childContextTypes: {
        isInternal: () => null;
    };
    constructor(props: AutoFormProps);
    getChildContext(): AutoFormContext;
    private onAutoFormChange;
    private renderChildren();
    static errorLabel(): JSX.Element;
    render(): JSX.Element;
}
export declare function makeFormEntry(formData: any, displayMode: DisplayMode, repo: SchemaRepository, erroneousProps: SchemaProperty[] | undefined, onAutoFormChange: AutoFormOnChangeType): (property: SchemaProperty, key: string) => JSX.Element;
