/// <reference types="react" />
import * as React from 'react';
import { AutoFormOnChangeType } from "./auto-form";
import { Type } from "./schema-property";
import { SchemaRepository } from "./schema-repo";
import { JsonPatchBuilder } from "./json-patch-builder";
export declare enum DisplayMode {
    View = "View",
    Edit = "Edit",
}
export interface AutoFormEvent {
    jsonPatch: JsonPatchBuilder;
    value?: any;
    key: string;
}
export interface EntryFormEvent<T> extends React.FormEvent<T> {
    value: any;
    key: string;
}
export declare type AutoViewEvent = React.FormEvent<HTMLInputElement> | AutoFormEvent;
export declare function entrySelector(key: string): string;
export interface EntryProps {
    repo: SchemaRepository;
    schemaId: string;
    entryKey: string;
    title: string;
    displayMode: DisplayMode;
    type: Type;
    value?: any;
    onChange?: AutoFormOnChangeType;
    valid: boolean;
}
export declare class Entry extends React.Component<EntryProps, {}> {
    static defaultProps: {
        displayMode: DisplayMode;
    };
    private renderByDisplayMode;
    constructor(props: EntryProps);
    private onChange;
    private renderInternalComponent();
    render(): JSX.Element;
}
