"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var auto_form_1 = require("./auto-form");
var skin_1 = require("./skin");
var component_renderer_1 = require("./component-renderer");
var DisplayMode;
(function (DisplayMode) {
    DisplayMode["View"] = "View";
    DisplayMode["Edit"] = "Edit";
})(DisplayMode = exports.DisplayMode || (exports.DisplayMode = {}));
function isFormEvent(e) {
    if (e.currentTarget) {
        return true;
    }
    return false;
}
function entrySelector(key) {
    return "entry_value_" + key;
}
exports.entrySelector = entrySelector;
var Entry = (function (_super) {
    __extends(Entry, _super);
    function Entry(props) {
        var _this = _super.call(this, props) || this;
        _this.onChange = function (e) {
            if (_this.props.onChange) {
                if (isFormEvent(e)) {
                    _this.props.onChange({
                        value: e.currentTarget.value,
                        key: _this.props.entryKey,
                    }); //TODO its not really good
                }
                else {
                    _this.props.onChange(e);
                }
            }
        };
        _this.renderByDisplayMode = (_a = {},
            _a[DisplayMode.Edit] = new skin_1.EditSkin(),
            _a[DisplayMode.View] = new skin_1.ViewSkin(),
            _a);
        return _this;
        var _a;
    }
    Entry.prototype.renderInternalComponent = function () {
        var childProps = Object.assign({}, __assign({}, this.props), (_a = {}, _a['data-automation-id'] = auto_form_1.fieldValueSelector(this.props.entryKey), _a), (this.props.valid) ? {} : { style: { borderColor: 'red' } }, (this.props.onChange) ? { onChange: this.onChange } : {});
        var skin = this.renderByDisplayMode[this.props.displayMode];
        return skin[this.props.type](childProps);
        var _a;
    };
    Entry.prototype.render = function () {
        var rest = component_renderer_1.getNonLocalChildProps(this.props);
        var comp = this.renderInternalComponent();
        return React.createElement("div", __assign({}, rest),
            React.createElement("label", { "data-automation-id": auto_form_1.fieldLabelSelector(this.props.entryKey) }, this.props.title),
            comp);
    };
    Entry.defaultProps = {
        displayMode: DisplayMode.View,
    };
    return Entry;
}(React.Component));
exports.Entry = Entry;
//# sourceMappingURL=form-entry.js.map