"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var jsonpatch = require("jsonpatch");
var JsonPatchBuilder = (function () {
    function JsonPatchBuilder(patch) {
        if (patch === void 0) { patch = []; }
        this.patch = patch;
    }
    JsonPatchBuilder.prototype.addNewObjectToPatch = function (propertyName, formDatum) {
        if (formDatum == undefined) {
            this.patch.unshift({
                op: 'add',
                path: '/' + propertyName,
                value: {}
            });
        }
    };
    JsonPatchBuilder.prototype.addRelativePathToExistingPatch = function (propertyName) {
        for (var i = 0; i < this.patch.length; i++) {
            this.patch[i].path = '/' + propertyName + this.patch[i].path;
        }
    };
    JsonPatchBuilder.prototype.prepandToPath = function (propertyName, formDatum) {
        this.addRelativePathToExistingPatch(propertyName);
        this.addNewObjectToPatch(propertyName, formDatum);
    };
    JsonPatchBuilder.prototype.initPath = function (propertyName, value, formDatum) {
        var op = 'replace';
        if (formDatum[propertyName] == undefined) {
            op = 'add';
        }
        this.patch = [{
                "op": op,
                "path": "/" + propertyName,
                "value": value
            }];
    };
    JsonPatchBuilder.prototype.applyOn = function (originalValue) {
        return jsonpatch.apply_patch(originalValue, this.patch);
    };
    return JsonPatchBuilder;
}());
exports.JsonPatchBuilder = JsonPatchBuilder;
//# sourceMappingURL=json-patch-builder.js.map