/// <reference types="react" />
import * as React from 'react';
import { Validator, ValidatorResult } from 'jsonschema';
import { SchemaProperty } from "./schema-property";
export interface AutoFormSchema {
    id: string;
    properties: {
        [key: string]: SchemaProperty;
    };
}
export declare class SchemaRepository {
    schemas: {
        [key: string]: AutoFormSchema;
    };
    controllers: {
        [key: string]: React.ComponentType;
    };
    validator: Validator;
    addSchema(schema: AutoFormSchema): void;
    addSchemas(schemas: AutoFormSchema[]): void;
    getSchema(id: string): AutoFormSchema;
    clear(): void;
    mapOverProperties<T>(id: string, propertyVisitor: (property: SchemaProperty, key: string) => T): Array<T>;
    registerController(controllerID: string, controller: React.ComponentType): void;
    getController(controllerID: string): React.ComponentType | null;
    validate(formData: any, schemaId: string): ValidatorResult;
}
