"use strict";
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var component_renderer_1 = require("./component-renderer");
var auto_form_1 = require("./auto-form");
var renderObjectType = function (childProps) {
    var key = childProps.entryKey;
    return React.createElement(auto_form_1.AutoForm, { repo: childProps.repo, key: key, entryKey: key, schemaId: childProps.schemaId, displayMode: childProps.displayMode, formData: childProps.value || {}, "data-automation-id": auto_form_1.autoFormSelector(key), onAutoViewChange: childProps.onChange }); //TODO remove any
};
function renderArrayType(childProps, skin) {
    var rest = component_renderer_1.getNonLocalChildProps(childProps);
    var comps = childProps.value.map(function (value, index) {
        var newAutomationId = childProps['data-automation-id'] + '_' + index;
        var newOnChange = function (e) {
            if (childProps.onChange) {
                var newArray = childProps.value.slice(0);
                newArray[index] = e.currentTarget.value;
                var newEvent = {
                    currentTarget: {
                        value: newArray
                    }
                };
                childProps.onChange(newEvent);
            }
        };
        var newChildProps = Object.assign({}, childProps, (_a = {}, _a['data-automation-id'] = newAutomationId, _a), { onChange: newOnChange });
        var innerComp = component_renderer_1.renderInnerComp(value, skin, newChildProps);
        return React.createElement("li", { "data-automation-id": newAutomationId + '_li', key: index }, innerComp);
        var _a;
    });
    return React.createElement("ol", __assign({}, rest), comps);
}
var ViewSkin = (function () {
    function ViewSkin() {
        var _this = this;
        this.renderBooleanForView = function (childProps) {
            var rest = component_renderer_1.getNonLocalChildProps(childProps);
            var newChildProps = Object.assign(rest, {
                type: "checkbox",
                disabled: true,
                checked: childProps.value,
            });
            return React.createElement("input", __assign({}, newChildProps));
        };
        this.renderNonBooleanForView = function (childProps) {
            var rest = component_renderer_1.getNonLocalChildProps(childProps);
            return React.createElement("label", __assign({}, rest), childProps.value);
        };
        this.boolean = this.renderBooleanForView;
        this.string = this.renderNonBooleanForView;
        this.number = this.renderNonBooleanForView;
        this.array = function (childProps) { return renderArrayType(childProps, _this); };
        this.object = renderObjectType;
    }
    return ViewSkin;
}());
exports.ViewSkin = ViewSkin;
var getValueFromNativeEvent = function (type, e) {
    var newValue;
    switch (type) {
        case 'boolean':
            newValue = e.target.checked;
            break;
        case 'number':
            newValue = parseInt(e.currentTarget.value);
            break;
        default:
            newValue = e.target.value;
    }
    return newValue;
};
var EditSkin = (function () {
    function EditSkin() {
        var _this = this;
        this.renderAnyTypeForEdit = function (childProps, type, nativeTypeOverride) {
            var rest = component_renderer_1.getNonLocalChildProps(childProps);
            var newChildProps = Object.assign(rest, {
                onChange: _this.onChangeByType(type, childProps.onChange),
                type: nativeTypeOverride || type
            });
            return React.createElement("input", __assign({}, newChildProps));
        };
        this.renderBooleanTypeForEdit = function (childProps) {
            var newChildProps = Object.assign({}, childProps, { checked: childProps.value });
            return _this.renderAnyTypeForEdit(newChildProps, 'boolean', 'checkbox');
        };
        this.boolean = this.renderBooleanTypeForEdit;
        this.string = function (childProps) { return _this.renderAnyTypeForEdit(childProps, "string"); };
        this.number = function (childProps) { return _this.renderAnyTypeForEdit(childProps, "number"); };
        this.array = function (childProps) { return renderArrayType(childProps, _this); };
        this.object = renderObjectType;
    }
    EditSkin.prototype.onChangeByType = function (type, onChange) {
        return function (e) {
            e.stopPropagation();
            var newEvent = {
                currentTarget: {
                    value: getValueFromNativeEvent(type, e)
                }
            };
            onChange(newEvent);
        };
    };
    return EditSkin;
}());
exports.EditSkin = EditSkin;
//# sourceMappingURL=skin.js.map