import {EntryProps} from "./form-entry";

export interface Skin {
    boolean: (childProps:{})=>JSX.Element;
    string: (childProps:{})=>JSX.Element;
    number: (childProps:{})=>JSX.Element;
    object: (childProps:{})=>JSX.Element;
    array: (childProps:{})=>JSX.Element;
    // null: (childProps:{})=>JSX.Element|null;
}

export function renderInnerComp(value: any, renderer: Skin, childProps?:EntryProps) {
    let typeString: string = ("" + typeof value);
    childProps = Object.assign(childProps,
        {value:value});
    if (value==null){
        typeString = 'null';
    }else if (Array.isArray(value)){
        typeString = 'array';
    }

    return (renderer as any)[typeString]({...childProps});
}

export const getNonLocalChildProps = function (childProps: EntryProps):any {
    const {repo, schemaId, entryKey, valid, displayMode, ...rest} = childProps;
    return rest;
};
