import * as jsonpatch from 'jsonpatch';

export class JsonPatchBuilder {
    constructor(public patch: any = []) {

    }

    private addNewObjectToPatch(propertyName: string, formDatum: any) {
        if (formDatum == undefined) {
            this.patch.unshift({
                op: 'add',
                path: '/' + propertyName,
                value: {}
            });
        }
    }

    private addRelativePathToExistingPatch(propertyName: string) {
        for (let i = 0; i < this.patch.length; i++) {
            (this.patch[i] as any).path = '/' + propertyName + (this.patch[i] as any).path;
        }
    }

    public prepandToPath(propertyName: string, formDatum: any) {
        this.addRelativePathToExistingPatch(propertyName);
        this.addNewObjectToPatch(propertyName, formDatum);
    }

    public initPath(propertyName: string, value: any, formDatum: any) {
        let op = 'replace';

        if (formDatum[propertyName]==undefined){
            op = 'add'
        }

        this.patch = [{
            "op": op,
            "path": "/" + propertyName,
            "value": value
        }];
    }

    applyOn(originalValue: {}): {} {
        return jsonpatch.apply_patch(originalValue, this.patch);
    }
}
